
class Producer extends Thread {
  ChannelOfInt out ;

  public Producer (ChannelOfInt out) {
    this.out = out ;
  }

  public void run() {
    while(true)
      out.send(1) ;
  }
}

class Consumer extends Thread {
  ChannelOfInt in ;

  public Consumer (ChannelOfInt in) {
    this.in = in ;
  }

  public void run() {
    while(true) {
      int result = in.recv() ;
      System.out.println("" + result) ;
    }
  }
}

class Accum extends Thread {
  ChannelOfInt in, out ;
  int total ;

  public Accum (ChannelOfInt in, ChannelOfInt out) {
    this.in  = in ;
    this.out = out ;

    total = 0 ;
  }

  public void run() {
    while(true) {
      total += in.recv() ;
      out.send(total) ;
    }
  }
}

class Filter extends Thread {

  // Filter removes all numbers which are multiples of `factor'

  ChannelOfInt in, out ;
  int factor ;

  public Filter (ChannelOfInt in, ChannelOfInt out, int factor) {
    this.in  = in ;
    this.out = out ;

    this.factor = factor ;
  }

  public void run() {
    while(true) {
      int n = in.recv() ;
      if(n % factor != 0 || factor == 1)
        out.send(n) ;
    }
  }
}

public class Eg3 {
  public static void main(String args[]) {
    ChannelOfInt c1 = new ChannelOfInt() ;
    ChannelOfInt c2 = new ChannelOfInt() ;
    ChannelOfInt c3 = new ChannelOfInt() ;

    Producer P = new Producer(c1) ;
    Accum    Q = new Accum(c1, c2) ;
    Filter   R = new Filter(c2, c3, 2) ;
    Consumer S = new Consumer(c3) ;

    P.start() ;
    Q.start() ;
    R.start() ;
    S.start() ;
  }
}


